// VCDemoPdxDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCDemoPdx.h"
#include "VCDemoPdxDlg.h"
#include "DlgProxy.h"
#include "pdxviewa.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVCDemoPdxDlg dialog

IMPLEMENT_DYNAMIC(CVCDemoPdxDlg, CDialog);

CVCDemoPdxDlg::CVCDemoPdxDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCDemoPdxDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCDemoPdxDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = NULL;
}

CVCDemoPdxDlg::~CVCDemoPdxDlg()
{
	// If there is an automation proxy for this dialog, set
	//  its back pointer to this dialog to NULL, so it knows
	//  the dialog has been deleted.
	if (m_pAutoProxy != NULL)
		m_pAutoProxy->m_pDialog = NULL;
}

void CVCDemoPdxDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCDemoPdxDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCDemoPdxDlg, CDialog)
	//{{AFX_MSG_MAP(CVCDemoPdxDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_SAVE2CSV, OnSave2csv)
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_BN_CLICKED(IDC_SAVE2SQL, OnSave2sql)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCDemoPdxDlg message handlers

BOOL CVCDemoPdxDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// check default radiobutton
	CButton* pRB = (CButton*)GetDlgItem(IDC_RBCOPY);
	pRB->SetCheck(1);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCDemoPdxDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCDemoPdxDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Automation servers should not exit when a user closes the UI
//  if a controller still holds on to one of its objects.  These
//  message handlers make sure that if the proxy is still in use,
//  then the UI is hidden but the dialog remains around if it
//  is dismissed.

void CVCDemoPdxDlg::OnClose() 
{
	if (CanExit())
		CDialog::OnClose();
}

void CVCDemoPdxDlg::OnOK() 
{
	if (CanExit())
		CDialog::OnOK();
}

BOOL CVCDemoPdxDlg::CanExit()
{
	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != NULL)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}

void CVCDemoPdxDlg::OnSave2csv() 
{
    //get the application's directory
	TCHAR home[MAX_PATH]; 
    GetModuleFileName(NULL, home, MAX_PATH); 
	
	TCHAR drive[MAX_PATH]; 
	TCHAR StartupPath[MAX_PATH]; 
	_tsplitpath(home, drive, StartupPath, NULL, NULL); 
	
	TCHAR PDXFileName[MAX_PATH], CSVFileName[MAX_PATH], SuccessMessage[MAX_PATH];
	strcpy(PDXFileName, drive);
	strcat(PDXFileName, StartupPath);
	strcat(PDXFileName, "\country.db");

	strcpy(CSVFileName, drive);
	strcat(CSVFileName, StartupPath);
	strcat(CSVFileName, "\country.csv");

	strcpy(SuccessMessage, "Data succesfully converted to CSV-file: ");
	strcat(SuccessMessage, CSVFileName);

	ITScalabiumParadoxReader pdx;
	pdx.CreateDispatch("PdxViewA.TScalabiumParadoxReader");
	
	pdx.SetFileName(PDXFileName);
	pdx.SaveToCSV(CSVFileName, ",", "'", 1);
	if (pdx.GetLastErrorMessage() == "") 
	    MessageBox(SuccessMessage, "Status", MB_OK);
	else 				
	    MessageBox(pdx.GetLastErrorMessage(), "Error", MB_OK);
}

void CVCDemoPdxDlg::OnLoad() 
{
    //get the application's directory
	TCHAR home[MAX_PATH]; 
    GetModuleFileName(NULL, home, MAX_PATH); 
	
	TCHAR drive[MAX_PATH]; 
	TCHAR StartupPath[MAX_PATH]; 
	_tsplitpath(home, drive, StartupPath, NULL, NULL); 
	
	TCHAR PDXFileName[MAX_PATH], ADOConnectionString[MAX_PATH], SuccessMessage[MAX_PATH];
	strcpy(PDXFileName, drive);
	strcat(PDXFileName, StartupPath);
	strcat(PDXFileName, "\country.db");

	strcpy(ADOConnectionString, "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=TEST.MDB;Persist Security Info=False");

	strcpy(SuccessMessage, "Data succesfully loaded to ADO datasource: ");
	strcat(SuccessMessage, ADOConnectionString);

	ITScalabiumParadoxReader pdx;
	pdx.CreateDispatch("PdxViewA.TScalabiumParadoxReader");
	
	pdx.SetFileName(PDXFileName);
	pdx.SetConnectionString(ADOConnectionString);
	pdx.SetTargetSQL("COUNTRY");

	CButton* pRB1 = (CButton*)GetDlgItem(IDC_RBADD);
	CButton* pRB2 = (CButton*)GetDlgItem(IDC_RBUPDATE);
	CButton* pRB3 = (CButton*)GetDlgItem(IDC_RBADDUPDATE);
	CButton* pRB4 = (CButton*)GetDlgItem(IDC_RBDELETE);
	CButton* pRB5 = (CButton*)GetDlgItem(IDC_RBCOPY);
	CButton* pRB6 = (CButton*)GetDlgItem(IDC_RBADDNEW);
	if (pRB1->GetCheck())
		pdx.SetMode(0);
	else
    if (pRB2->GetCheck())
		pdx.SetMode(1);
	else
    if (pRB3->GetCheck())
		pdx.SetMode(2);
	else
    if (pRB4->GetCheck())
		pdx.SetMode(3);
	else
    if (pRB5->GetCheck())
		pdx.SetMode(4);
	else
    if (pRB6->GetCheck())
		pdx.SetMode(5);

	pdx.SetUniqueFields("NAME");
	pdx.Execute();
	if (pdx.GetLastErrorMessage() == "") 
	    MessageBox(SuccessMessage, "Status", MB_OK);
	else 				
	    MessageBox(pdx.GetLastErrorMessage(), "Error", MB_OK);	
}

void CVCDemoPdxDlg::OnSave2sql() 
{
    //get the application's directory
	TCHAR home[MAX_PATH]; 
    GetModuleFileName(NULL, home, MAX_PATH); 
	
	TCHAR drive[MAX_PATH]; 
	TCHAR StartupPath[MAX_PATH]; 
	_tsplitpath(home, drive, StartupPath, NULL, NULL); 
	
	TCHAR PDXFileName[MAX_PATH], SQLFileName[MAX_PATH], SuccessMessage[MAX_PATH];
	strcpy(PDXFileName, drive);
	strcat(PDXFileName, StartupPath);
	strcat(PDXFileName, "\country.db");

	strcpy(SQLFileName, drive);
	strcat(SQLFileName, StartupPath);
	strcat(SQLFileName, "\country.sql");

	strcpy(SuccessMessage, "Data succesfully converted to SQL-file: ");
	strcat(SuccessMessage, SQLFileName);

	ITScalabiumParadoxReader pdx;
	pdx.CreateDispatch("PdxViewA.TScalabiumParadoxReader");
	pdx.SetFileName(PDXFileName);
	pdx.SaveToSQL(SQLFileName, "COUNTRY");
	if (pdx.GetLastErrorMessage() == "") 
	    MessageBox(SuccessMessage, "Status", MB_OK);
	else 				
	    MessageBox(pdx.GetLastErrorMessage(), "Error", MB_OK);
	
}
